function ax = makenicegraph (transducer,ctdrgb,numpingstoavg,name,type2LAY, type3LAY, threshLAY,middles,fig,distances,ydist,ys)

figure(fig); clf;

im = image(ctdrgb,'ydata', ys,'xdata',[1 size(transducer,1)]);
xlim([1 size(transducer,1)]); 
hold on;
a = [.35 .5 .3 .55 .4]; %alphadata (1 4 5)
t = [3 3 1.5]; %line thickness
c = 'rckck'; %colors
invthresh = 1; %if you want the threshold to be highlighted or not (1 = not highlighted)
onlythresh = 0;
if threshLAY(1,1) ==0; threshLAY(:,1) = []; end % weird problem of leading ping num = 0 (added from Sensitivity)
if type2LAY(1,1) ==0; type2LAY(:,1) = []; end
if type3LAY(1,1) ==0; type3LAY(:,1) = []; end

% makes the layer files the entire size of the imported data.  Prevents an
% error in certain situations
testLAY = -ones(size(threshLAY,1),ceil(size(transducer,1)/numpingstoavg));
testLAY(1,:) = 1:numpingstoavg:size(transducer,1); oi = testLAY;
oi(:,ismember(testLAY(1,:),threshLAY(1,:))) = threshLAY; threshLAY = oi; oi = testLAY;
oi(:,ismember(testLAY(1,:),type2LAY(1,:))) = type2LAY; type2LAY = oi; oi = testLAY;
oi(:,ismember(testLAY(1,:),type3LAY(1,:))) = type3LAY; type3LAY = oi; 




LAYs = {type2LAY, type3LAY, threshLAY, type3LAY, threshLAY};
ax = get(figure(fig),'currentaxes');
p = zeros(3,1);
testLAY = cell(5,1);
Xs = cell(3,1);
Ys = cell(3,1);


for k = 1:5
    testLAY{k} = LAYs{k}(2:end,:);
    testLAY{k}(testLAY{k}<1) = 0;
    testLAY{k}(testLAY{k}>1) = 1;
    if ismember(k,5)&&invthresh
        testLAY{k} = ~testLAY{k};
        a(k) = .5; %set([p(4) p(1)],'facealpha',.55);
    end
    testLAY{k}(:,end+1:end+2) = 0;
    testLAY{k}(:,2:end) = testLAY{k}(:,1:end-1);
    testLAY{k}(:,1) = 0;
    if ismember(k,[4 5]) % for display purposes, gets rid of the thinner layers from the patches so that only the unique areas are counted as patches
        testLAY{k}=testLAY{k}-testLAY{k-3};
        testLAY{k}(testLAY{k}<0) = 0;
    end
    
%     figure(911);
    [~, h] = contourf(testLAY{k},1);
    patches = get(h,'children');
    x = cell(1,length(patches)-1);
    y = x;
    if k<4; Xs{k} = cell(length(x),1); Ys{k} = cell(length(y),1); end % Xs & Ys for making the surrounding border lines.  This procedure is to get rid of gaps so they aren't graphed
    for i = 1:length(patches)-1
        x{i} = get(patches(i),'xdata')';
        y{i} = get(patches(i),'ydata')';
        x{i} = numpingstoavg*x{i}-(2*numpingstoavg-1);
        if ismember(k,1:3)
            oi = round(x{i});
            [oix I] = sort(oi);
            sec = SplitVec(I,'consecutive','bracket');  % this for loop ensures that the sections you are looking at are consecutive around the edge
            for ii = 1:length(sec(:,1))
                oix(sec(ii,1):sec(ii,2)) = oix(sec(ii,1):sec(ii,2)) + .0001*(ii-1);
            end
            sections = SplitVec(oix,'equal','bracket');
            sections = sections(SplitVec(oix,'equal','length')>2,:);
            oiy = y{i}(I);
            todel = [];
            for ii = 1:length(sections(:,1))
                todels = sections(ii,1):sections(ii,2);
                [m11, m1] = min(oiy(todels));
                [m22, m2] = max(oiy(todels));
                todels([m1 m2]) = [];
                if m22-m11<=ydist/2; todels = []; end %kind of arbitrary how big the skip is to connect
                todel = [todel todels];
            end
            Xs{k}{i} = x{i}; Xs{k}{i}(I(todel)) = nan; %Xs{k}{i} = numpingstoavg*Xs{k}{i}-(2*numpingstoavg-1);
            Ys{k}{i} = y{i}; Ys{k}{i}(I(todel)) = nan;
        end
    end
    if onlythresh; oi = 3; else oi = [1 4 5]; end
    if ismember(k,oi)
        [f, v] = poly2fv(x, y); hold on;
        p(k) = patch('Faces', f, 'Vertices', v, 'FaceColor', c(k), 'EdgeColor', 'none','facealpha',a(k),'parent',ax);
    end
    delete(h);
end

if onlythresh; oi = 3; t(3) = 3; else oi = 3:-1:1; end
for k = oi % graph edges
    for i = 1:length(Xs{k})
        plot(Xs{k}{i},Ys{k}{i},c(k),'linewidth',t(k));
        if ismember(k,[1 2])
            plot(Xs{k}{i},Ys{k}{i},'k','linewidth',.1);
        end
    end
end

if ~onlythresh
    m = zeros(size(middles)); %graph middles
    for i = 1:length(middles)
        if m~=0; delete(m(i)); end
        m(i) = plot(middles{i}(1,:),middles{i}(2,:),'k-.','linewidth',1.4);
    end
end

%change x-axis to distance (km)
oi = get(gca,'xtick');
xs = get(gca,'xlim');
gooddist = round(distances(oi(2))-distances(oi(1)));
if gooddist<=1; gooddist = round(10*(distances(oi(2))-distances(oi(1))))/10; end
if gooddist<=.1; gooddist = round(100*(distances(oi(2))-distances(oi(1))))/100; end
b = nan(1,floor((distances(xs(2))-distances(xs(1)))/gooddist));
for i = 1:length(b)
    [~, b(i)] = min(abs(distances(xs(1):xs(2))-distances(xs(1))-gooddist*i));
end
b= b+xs(1);
b(diff(b)==0) = b(diff(b)==0)-1;
b(diff(b)==0) = b(diff(b)==0)-1;
set(gca,'xtick',b);

set(gca,'xticklabel',gooddist:gooddist:gooddist*length(b),'fontsize',15,'box','off');
ylabel('Depth (m)');
xlabel('Distance along transect (km)');
title(name);
ylim([0 600]);

ax = gca;

% pos = get(gca,'position');
% cb = axes('position', [pos(1)+pos(3)+(1-pos(1)-pos(3))/7 pos(2) (1-pos(1)-pos(3))/5 pos(4)]);
% image (imread('C:\Users\kbblab\Documents\Pelagic Ecology\Thesis Data\LD paper\color bar.png'),'ydata',[-46.6 -78.6]);
% set(cb,'xtick',[],'ytick',-78:-47,'ydir','normal','xdir','rev','box','off','yaxislocation','right','yticklabels',[-78:-74 -72:-66 -64:-56 -54:-48 -46:-43],'fontweight','bold','layer','bottom');
% ylabel('Volume Scattering (S_{v} dB)');
% set(gcf,'color','w');