function [transducers,distances,times,dates] = setupvars (fileloc, filename, difareas, freqs, locat, bfileloc, bfilename)

% get ping and ducer info
% reads csv files into matrices for manipulation


if difareas
    numareas = length(filename);
    trans = cell(length(filename),1);
    dist = trans;
    tms = dist;
    dts = tms;
else
    numareas = 1;
end

for ii = 1:numareas
    acousticthreshold = -1000;
    CTDthresh = [];
    
    if difareas
        fn = filename(ii); fre = freqs(ii);
    else fn = filename; fre = freqs;
    end
    
%     if ~TOW
    transducers = EVcsv2matlab(fileloc, fn, acousticthreshold,CTDthresh,fre, locat, false);
%     else
%         [transducers botdepth topdepth bottime toptime] = EVcsv2matlab(fileloc, fn, acousticthreshold,CTDthresh,fre, TOW);
%     end
    
    fid=fopen([fileloc fn{1}]);
    
    header=fgetl(fid); % necessary line for queing fgetl
    line1=fgetl(fid);
    line1=textscan(line1,'%s','delimiter',',');
    samplenum=length(line1{1})-13; %the length of the file minus all the headers (so just the # of pings)
    pingformats = repmat('%f32',1,samplenum);
    fclose(fid);
    fid=fopen([fileloc fn{1}]);
    data1=textscan(fid,['%f32%f32%f32%s%s%f32%f32%f32%f32%f32%f32%f32%f32' pingformats],'delimiter',',','headerLines',1);
    fclose(fid);
    timedata = [data1{4:5}];
    dates=timedata(:,1);
    dates=regexprep(dates,'-','');
    times=timedata(:,2);
    times=regexprep(times,':','');
    distances = data1{2};
    distances = 1.852*distances; %converts nautical miles to km;
%     if TOW
%         ttimes = datenum([vertcat(timedata{:,1}) repmat(' ',length(timedata(:,1)),1) vertcat(timedata{:,2})]);
%         for k = 1:length(transducers)
%             
%             for iii = 1:length(ttimes(:,1))
%                 [~,b] = min(abs(bottime-ttimes(iii)));
%                 [~,t] = min(abs(toptime-ttimes(iii)));
%                  transducers{k}(iii,1:max(round(topdepth(t)),5)) = nan;
%                 transducers{k}(iii,round(botdepth(b)):end) = nan;
%             end
%         end
%     end
    % now other bad data regions
    tic; % the nans should be the parts that had data removed...  currently, the original baddata regions have -999, but the new have nans (must be something with one of the subfuctions).  I'll incorporate something to account for long vertical bars of nans
    for k = 1:length(transducers)
        [J I] = find(isnan(transducers{k}(4:end-3,4:end-3)')); %makes I the rows (samplenum) in order (J is depths)
        J = J+3; %accounts for the boundary condition
        I = I+3;
        Is = unique(I);
        for m = 1:length(Is)
            i = Is(m); % not sure why I couldn't just do for i = unique(I), but for some reason this didn't iteratively go through i like I expected
            if sum(isnan(transducers{k}(i,:)))<length(transducers{k}(1,:))-10 %don't do this if (almost) the whole column is nans
                oi1 = 3; else oi1 = 0; end
            sampledepths = J(I==i);
            for n = 1:length(sampledepths)
                j = sampledepths(n);
                if sum(isnan(transducers{k}(i,j:end)))==length(transducers{k}(i,j:end));
                    oi = 0; else oi = oi1; end %if the nans go all the way to the bottom, don't average in the values from above the baddata patch
                toavg = 10.^(transducers{k}(i-3:i+3,j-oi:j+oi)/10);
                transducers{k}(i,j) = 10*log10(nansum(nansum(toavg))/length(find(~isnan(toavg))));
            end
        end
    end
%     if TOW
%         ttimes = datenum([vertcat(timedata{:,1}) repmat(' ',length(timedata(:,1)),1) vertcat(timedata{:,2})]);
%         for k = 1:length(transducers)
%             
%             for iii = 1:length(ttimes(:,1))
%                 [~,b] = min(abs(bottime-ttimes(iii)));
%                 [~,t] = min(abs(toptime-ttimes(iii)));
%                 transducers{k}(iii,1:round(topdepth(t))+5) = nan;%first five meters
%                 transducers{k}(iii,round(botdepth(b)):end) = nan;
%             end
%         end
%     end
if nargin > 5 % if you should remove the bottom
    botinfo = dlmread([bfileloc bfilename{ii}],' ',2,0);
    botinfo(:,2) = round(botinfo(:,2)/10000);
    botstr = num2str(botinfo(:,2));
    for iii = 1:length(botstr(:,1))
        for iv = 1:6; if strcmp(botstr(iii,iv),' '); botstr(iii,iv) = '0'; else break; end; end
    end
    bottimes = datenum([num2str(botinfo(:,1)) botstr],'yyyymmddHHMMSS');
    ttimes = datenum([vertcat(timedata{:,1}) repmat(' ',length(timedata(:,1)),1) vertcat(timedata{:,2})]);
    for iii = 1:length(ttimes(:,1))
        [~,b] = min(abs(bottimes-ttimes(iii)));
        transducers{ii}(iii,round(botinfo(b,4)):end) = nan;
    end
end

disp(['CSV process time for ' char(fn)]);
toc;
    
    if difareas
        trans{ii} = transducers{1};
        dist{ii} = distances;
        tms{ii} = times;
        dts{ii} = dates;
    end
end

if difareas
    transducers = trans;
    distances = dist;
    times = tms;
    dates = dts;
end

