function [transducers bottomdepth topdepth bottime toptime] = EVcsv2matlab(fileloc, filename, threshold,upperthresh,freqs,locat, TOW)
%%
% if isempty(TOW); TOW = false; end
for i = 1:length(filename)
    tic;
    %     if TOW && i == 1
%         [nameb loc] =uigetfile('*.*', 'Select echoview bottom file');
%         [namet loc2] =uigetfile('*.*', 'Select echoview towed depth file');
%         [bottomdepth bottime] = xlsread([loc nameb]); bottomdepth = bottomdepth(:,5);
%         [topdepth toptime] = xlsread([loc2 namet]); topdepth = topdepth(:,5);
%         bottime =  datenum([vertcat(bottime{2:end,1}) repmat(' ',length(bottime(2:end,1)),1) vertcat(bottime{2:end,2})]);
%         toptime = datenum([vertcat(toptime{2:end,1}) repmat(' ',length(toptime(2:end,1)),1) vertcat(toptime{2:end,2})]);
%         for ii = 1:length(bottime) % converts botdepth to real bottom depth by subtracting off the depth of the towfish
%             [~,b] = min(abs(toptime-bottime(ii)));
%             bottomdepth(ii)= bottomdepth(ii)+topdepth(b);
%         end
%         samplenum = round(max(bottomdepth));
%     elseif ~TOW
%         switch freqs(i)  %sets the maximum depth to grab samples at (saves computer time since the rest will be thrown out anyway
%             case {18,38,70}
%                 samplenum = 600; %18,38 & 70 khz
%             case {120}
%                 samplenum = 300;  %120 khz
%             otherwise
%                 samplenum = 200; %200 khz
%         end
%     end
    samplenum = freqs(i);
    numlines = str2num(perl([locat 'subfunctions\subsubfunctions\Previously Published\countlines.pl'],[fileloc filename{i}]));%uses a perl script to count the number of lines
    startdepth = dlmread([fileloc filename{i}],',',[1 8 1 8]); %assumes all samples have the same start depth.  Would have to add a for loop to deal with different samples having different start depths.
    M = dlmread([fileloc filename{i}],',',[1 13 numlines-1 samplenum+12-startdepth]);
    disp(['dlmread time for ' char(filename{i})]); toc
    M(M<-10000) = NaN;
    M(M==-999) = 10000;
    randM = 0.2.*rand(size(M))+threshold-.1; %adding a tiny bit of wiggle to the cut off point prevents singular matrices during the Mahalanobis calculations (irrelevant for current version which does not rely on this process)
    M(M<=threshold) = -999; 
    M(M==10000) = -999;
    if ~isempty(upperthresh)
        M(isnan(M)) = pi;
        M(M>upperthresh) = NaN;
        oi = find(isnan(M));
        r = size(M,1); c = size(M,2);
        linM = 10.^(M/10);
        for j = 1:length(oi)
            r1 = mod(oi(j)-1,r)+1;
            c1 = ceil(oi(j)/r);
            M(oi(j)) = 10*log10(nanmean(nanmean(linM(max(1,r1-2):min(r,r1+2),max(1,c1-2):min(c,c1+2)))));
        end
        M(M==pi) = NaN;
    end
    
    switch i  %sets up the matrices for each transducer
        case {1}
            transducers = {[-999*ones(numlines-1,startdepth) M]}; %38 khz
        case {2}
            transducers = [transducers [-999*ones(numlines-1,startdepth) M]]; %70 khz
        case {3}
            transducers = [transducers [-999*ones(numlines-1,startdepth) M]];  %120 khz
        otherwise
            transducers = [transducers [-999*ones(numlines-1,startdepth) M]]; %200 khz
    end
end
%transducers = {T1; T2; T3; T4};
end