function [TlayersT TlayersB GlayersT GlayersM GlayersB t] = candidatelayers(transducer,medwindow,numpingstoavg,minv,thresh,mingap)


% medwindow = 11; %median filter the window first (The window is win/2 on each side of the middle).  Smooths layers and gets rid of single loud pings
% numpingstoavg = 7; %horizontally 
% minv = 12;
% thresh = -78;
% mingap = 20;
tic
area = medfilt2(transducer',[1,medwindow]);
numgraphs = floor(size(area,2)/numpingstoavg);

% fig = figure;
% set(fig, 'WindowStyle', 'docked');
% set(gca,'ydir','rev');
% image(ctdrgb,'ydata', [5 605],'xdata',1:size(area,2),'alphadata',.3);
% xlim([1 size(area,2)]); hold on;

TlayersT = cell(1,numgraphs);
TlayersB = cell(1,numgraphs);
GlayersB = cell(1,numgraphs);
GlayersM = cell(1,numgraphs);
GlayersT = cell(1,numgraphs);
Glayers = cell(1,numgraphs);

for j = 1:numgraphs
    linE = nanmean(10.^(area(:,(j-1)*numpingstoavg+1:j*numpingstoavg)/10),2);
    depthrange = find(linE>10^-99.9);
    if isempty(depthrange); continue; end
    linE(isnan(linE)) = 0;
    linE(depthrange(1)-2:depthrange(end)) = runmean(linE(depthrange(1)-2:depthrange(end)),3);
    bottom = findVEEC(linE,minv,thresh); % minv must be an integer
    if ~isempty(bottom)
        top = sort(topVEEC(linE,bottom,minv,thresh,mingap));
    else top = [];
    end
    if length(top)>1
        for ii = 1:length(top)-1
            bottom = [bottom findVEEC(linE(top(ii):top(ii+1)-1),minv,thresh)+top(ii)-1];
        end
    end
    bottom = sort(bottom);
    
    %             LINES{i}{j} = linE;
    if length(top)~=length(bottom)
        if length(top)>length(bottom)
            temptop = nan(0);
            for ii = 1:length(bottom)
                temptop(ii) = max(top(top<bottom(ii)));
            end
            top = temptop';
        end
        if length(bottom)>length(top)
            temptop = nan(0);
            for ii = 1:length(top)
                temptop(ii) = min(bottom(bottom>top(ii)));
            end
            bottom = temptop;
        end
    end
    
    if ~isempty(top)
        TlayersT{j}(:,2) = top;
        TlayersT{j}(:,1) = (j-1)*numpingstoavg+1;
        TlayersB{j} = TlayersT{j};
        TlayersB{j}(:,2) = bottom';
    end
    
%     plot(repmat((j-1)*numpingstoavg+1,1,length(bottom)),bottom,'gx','markersize',12,'linewidth',3);
%     plot(repmat((j-1)*numpingstoavg+1,1,length(top)),top,'rx','markersize',12,'linewidth',3);
    
    if ~isempty(top)
        subs  = sublayers(linE,[top bottom'],minv,thresh);
        oi = vertcat(subs{:});
        GlayersB{j}(:,2) = oi(:,3);
        GlayersB{j}(:,1) = (j-1)*numpingstoavg+1;
        GlayersM{j} = GlayersB{j};
        GlayersM{j}(:,2) = oi(:,2);
        GlayersT{j} = GlayersB{j};
        GlayersT{j}(:,2) = oi(:,1);
        Glayers{j} = [GlayersT{j} GlayersM{j}(:,2) GlayersB{j}(:,2)];
        
        
%         for ii = 1:length(subs)
%             for jj = 1:length(subs{ii}(:,1))
%                 plot([(j-1)*numpingstoavg+1+jj (j-1)*numpingstoavg+1+jj],subs{ii}(jj,[1 3]),'g','linewidth',3);
%                 plot((j-1)*numpingstoavg+1+jj,subs{ii}(jj,2),'kx','linewidth',3,'markersize',14);
%                 
%             end
%         end
    end
%     ylim([0 600]);
end
% title( filename);
t = toc;