function [tracksT tracksB] = cutoffcrossings (tracksT,tracksB,numpingstoavg,minh,type,minv)

% tracksT = tracks{3};
% tracksB = tracks{5};
if nargin<5
    type = '';
end

i = 1;
while i <= length(tracksT);
    toplength = length(tracksT{i});
    j = 1;
    tracksT{i} = int32(tracksT{i});
    while j <= length(tracksB)
        tracksB{j} = int32(tracksB{j}); % there were rounding issues
        botlength = length(tracksB{j});
        if sum(ismember(tracksB{j}(1,:),tracksT{i}(1,:))) == 0
            j = j+1; continue
        else
            ping1 = min(tracksB{j}(1,1),tracksT{i}(1,1));
            ping2 = max(tracksB{j}(1,end),tracksT{i}(1,end));
            combo = nan(4,(ping2-ping1)/numpingstoavg+1);
            combo(1,:) = ping1:numpingstoavg:ping2;
            combo(2,ismember(combo(1,:), tracksT{i}(1,:))) = tracksT{i}(2,:);
            combo(3,ismember(combo(1,:), tracksB{j}(1,:))) = tracksB{j}(2,:);
            combo(4,:) = sign(combo(3,:)-combo(2,:));
            if strcmp(type,'thresh')
                combo(4,:) = sign(combo(3,:)-(combo(2,:)+minv)); %if thresh, move the tops minv down in the water column to ensure they stay seperated
            end
            begs = nan(1,2);
            begs(1) = find(~isnan(combo(2,:)),1);
            begs(2) = find(~isnan(combo(3,:)),1);
            ends = nan(1,2);
            ends(1) = find(~isnan(combo(2,:)),1,'last');
            ends(2) = find(~isnan(combo(3,:)),1,'last');
            if abs(nansum(combo(4,:))) == nansum(abs(combo(4,:)))
                j = j+1; continue
            else
                if nansum(combo(4,:)) == 0
                    crossed = find(combo(4,:) == -1 | combo(4,:) == 0); %-1 is arbitrary.  It's rare that this happens, but when it does you just have to choose which one to clip
                else
                    crossed = find(combo(4,:) == -sign(nansum(combo(4,:))) | combo(4,:) == 0); %this chooses the spots with the shortest section that is abnormal
                end
                % find any short "normal" sections and make them abnormal
                % if they aren't worth being a whole layer on their own
                sections = find(diff(crossed)<minh & diff(crossed)>1);
                newsec = [];
                for ii = 1:length(sections)
                    newsec = [newsec crossed(sections(ii))+1:crossed(sections(ii)+1)-1];
                end
                if crossed(end) > min(ends) - minh && crossed(end)<min(ends) % count short end sections as crossed so that they can get snipped
                    newsec = [newsec crossed(end)+1:min(ends)];
                end
                crossed = sort([crossed newsec]);
                
                sections = [1 find(diff(crossed)>1)+1 length(crossed)+1]; % first of each section & length+1
                
                for ii = 1:length(sections)-1
%                     if strcmp(type,'thresh')
%                         combo(2:3,crossed(sections(ii):sections(ii+1)-1)) = NaN; % if you're dealing with threshold layers, get rid of the crossed section from both pieces
%                         continue
%                     end
                    
                    % if a section is at the beginning or end 
                    if ismember(crossed(sections(ii)),begs) 
                        if abs(begs(1)-begs(2))<minh/2 % if the two beginnings are close together
                            combo((toplength>botlength)+2,crossed(sections(ii):sections(ii+1)-1)) = NaN; %get rid of section from shorter one
                        else
                            combo(find(begs == crossed(sections(ii)))+1,crossed(sections(ii):sections(ii+1)-1)) = NaN; %get rid of section that ends
                        end
                        continue
                    end
                    if ismember(crossed(sections(ii+1)-1),ends)
                        if abs(ends(1)-ends(2))<minh/2 % if the two beginnings are close together
                            combo((toplength>botlength)+2,crossed(sections(ii):sections(ii+1)-1)) = NaN; %get rid of section from shorter one
                        else
                            combo(find(ends == crossed(sections(ii+1)-1))+1,crossed(sections(ii):sections(ii+1)-1)) = NaN; %get rid of section that ends
                        end
                        continue
                    end
                    % else cut it out of the shorter one? why not?
                    combo((toplength>botlength)+2,crossed(sections(ii):sections(ii+1)-1)) = NaN; %get rid of section from shorter one
                end
                %remake tracks
                sectionsT = find(~isnan(combo(2,:)));
                if ~isempty(sectionsT) % added this to fix an isempty error
                sections = [1 find(diff(sectionsT)>1)+1 length(sectionsT)+1];
                for ii = 1:length(sections)-1
                    if ii == 1
                        tracksT{i} = int32(combo(1:2,sectionsT(sections(ii)):sectionsT(sections(ii+1)-1)));
                    else tracksT{end+1} = int32(combo(1:2,sectionsT(sections(ii)):sectionsT(sections(ii+1)-1)));
                    end
                end
                end
                sectionsB = find(~isnan(combo(3,:)));
                if ~isempty(sectionsB)
                sections = [1 find(diff(sectionsB)>1)+1 length(sectionsB)+1];
                for ii = 1:length(sections)-1
                    if ii == 1
                        tracksB{j} = int32(combo([1 3],sectionsB(sections(ii)):sectionsB(sections(ii+1)-1)));
                    else tracksB{end+1} = int32(combo([1 3],sectionsB(sections(ii)):sectionsB(sections(ii+1)-1)));
                    end
                end
                end
            end
        end
        j = j+1;
    end
    i = i+1;
end
[~, I] = sort(cellfun(@length,tracksT),'descend');
tracksT = tracksT(I);
[~, I] = sort(cellfun(@length,tracksB),'descend');
tracksB = tracksB(I);

                

                