function [tracks n_tracks] = davestracker (points,xdist,ydist,mintracklength,vdistmin,graphtracks)

% xdist = 50; %for testing purposes
% ydist = 30;
% points = pointscopy;
% mintracklength = 60;
% graphtracks = true;

firstnonempty = find(cell2mat(cellfun(@(x) ~isempty(x),points,'uniformoutput',0)),1);
% points = points(firstnonempty:end);

pointscopy = points;
tracks = cell(1); tracks(1) = [];
activetracks = cell(1); activetracks(1) = [];
postracks = cell(1,length(points{firstnonempty}(:,1)));
for i = 1:length(points{firstnonempty}(:,1))
    postracks{i} = [1; points{firstnonempty}(i,:)'];
end


for i = firstnonempty+1:length(points) % the first entry in points is already in postracks
if isempty(points{i})
    continue
end
    
    
testpoints = points(max(2,i-xdist):min(end,i+xdist));
distances = nan(length(activetracks),1);
xs = distances;
ys = distances;
unlinkedtracks = activetracks;

if ~isempty(activetracks)
    done = false;
    [~, ord] = sort(cellfun(@(x) size(x,2),activetracks),'descend'); %orders the activetracks so the longest is #1 (helps with prioritization- especially for avoiding crossing)
    activetracks = activetracks(ord);
    unlinkedtracks = activetracks;
else done = true;
end

while ~done % for active tracks
    Loc = find(cellfun(@(x) any(x(:)==-2*xdist),unlinkedtracks)==0); % finds the unlinked tracks that aren't yet linked
    for j = Loc
        point = unlinkedtracks{j}([1 3],end);
        point(1) = point(1)-(max(i,xdist+2)-1-xdist); % takes the pointnumber and puts it in relation to
        [xs(j) ys(j) distances(j)] = link(point,testpoints,xdist,ydist);
    end
    
    [a b] = sort(distances); alltoofar = true;
    for k = 1:length(b) % finds the first distance that is linkable because it is in the current frame or before
        if xs(b(k))<=xdist+1 && xs(b(k))<=i-1; % the i-1 condition is for the first few points where the frame of interest is not in the middle of the testpoints
                
            tooclosevert = false;
            if  ~isnan(a(1)) && b(k)~=1 % checks that the depth doesn't cross (or get too close to) a longer track's depth
                currentpoint = [testpoints{xs(b(k))}(1,1) testpoints{xs(b(k))}(ys(b(k)),2)];
                otherdepths = cellfun(@(x) x(3,find(abs(x(2,:)-currentpoint(1))==min(abs(x(2,:)-currentpoint(1))),1,'first')),activetracks(1:b(k)-1)); %finds the depths of longer tracks at the same x location
                if any(abs(currentpoint(2)-otherdepths) < vdistmin)
                    tooclosevert = true;
                end
            end
                       
            if ~tooclosevert
                b = b(k);
                alltoofar = false;
                break;
            end
        end
    end

    if xs(b(1))<=xdist+1 && xs(b(1))<=i-1 && ~isnan(a(1)) && ~tooclosevert
        %replace two lines below, keeps organized when you are looking at frames before current frame activetracks{b}(:,end+1) = [i; testpoints{xs(b)}(1,1); testpoints{xs(b)}(ys(b),2)];
        activetracks{b}(:,end+1) = [xs(b(1))+(max(i,xdist+2)-1-xdist); testpoints{xs(b)}(1,1); testpoints{xs(b)}(ys(b),2)];
        unlinkedtracks{b}(:,end+1) = [xs(b(1))+(max(i,xdist+2)-1-xdist); testpoints{xs(b)}(1,1); testpoints{xs(b)}(ys(b),2)];
        
        testpoints{xs(b)}(ys(b),:) = []; % you linked a point, so it's no longer eligible
        points{max(2,i-xdist)-1+xs(b)}(ys(b),:) = [];
        if xs(b) == xdist+1 || xs(b) == i-1;
            unlinkedtracks{b} = [-2*xdist; -2*xdist; -2*xdist]; % if you just linked to the current frame, ensures that point won't be tested anymore
            xs(b) = nan;
            ys(b) = nan;
            distances(b) = nan;
        end
    end
    if mean(mean(horzcat(unlinkedtracks{:}),2)) == -2*xdist || isnan(a(1)) || alltoofar% if all tracks are linked or no points meet the linking criteria or none of the points link to the current frame or before
        Loc = find(cellfun(@(x) any(x(:)==-2*xdist),unlinkedtracks)==0);
        todel = [];
        for j = Loc
            if unlinkedtracks{j}(1,end) < i - xdist % if there are unlinked tracks that stretch too far back, they're done
                tracks{end+1} = activetracks{j};
                todel(end+1) = j;
            end
            if j == Loc(end)
                activetracks(todel) = [];
            end
        end
        
        done = true;
    end
end
% now postracks (the tracks that are not yet long enough to be full tracks
% and which don't get any priority in tracking)

distances = nan(length(postracks),1);
xs = distances;
ys = distances;
unlinkedtracks = postracks;
if ~isempty(postracks)
    done = false;
    [~, ord] = sort(cellfun(@(x) size(x,2),postracks),'descend');
    postracks = postracks(ord);
    unlinkedtracks = postracks;
else done = true;
end
% m = 0;
% for m = 1:50
%     if done
%         break;
%     end
while ~done
    Loc = find(cellfun(@(x) any(x(:)==-2*xdist),unlinkedtracks)==0); % finds the unlinked tracks that aren't yet linked
    for j = Loc
        point = unlinkedtracks{j}([1 3],end);
        point(1) = point(1)-(max(i,xdist+2)-1-xdist); % takes the pointnumber and puts it in relation to
        [xs(j) ys(j) distances(j)] = link(point,testpoints,xdist,ydist);
    end
    
    [a b] = sort(distances); alltoofar = true;
    for k = 1:length(b) % finds the first distance that is linkable because it is in the current frame or before
        if xs(b(k))<=xdist+1 && xs(b(k))<=i-1; % the i-1 condition is for the first few points where the frame of interest is not in the middle of the testpoints
                
            tooclosevert = false;  % this if (to check for crossings of tracks)
            if  ~isnan(a(1)) && ~(isempty(activetracks) && b(k)==1) % checks that the depth doesn't cross (or get too close to) a longer track's depth
                currentpoint = [testpoints{xs(b(k))}(1,1) testpoints{xs(b(k))}(ys(b(k)),2)];
                otherdepths = cellfun(@(x) x(3,find(abs(x(2,:)-currentpoint(1))==min(abs(x(2,:)-currentpoint(1))),1,'first')),[activetracks postracks(1:b(k)-1)]); %finds the depths of longer tracks at the same x location
                if any(abs(currentpoint(2)-otherdepths) < vdistmin)
                    tooclosevert = true;
                end
            end
                       
            if ~tooclosevert
                b = b(k);
                alltoofar = false;
                break;
            end
        end
    end
    
    if xs(b(1))<=xdist+1 && xs(b(1))<=i-1 && ~isnan(a(1)) && ~tooclosevert
        postracks{b}(:,end+1) = [xs(b(1))+(max(i,xdist+2)-1-xdist); testpoints{xs(b)}(1,1); testpoints{xs(b)}(ys(b),2)];
        unlinkedtracks{b}(:,end+1) = [xs(b(1))+(max(i,xdist+2)-1-xdist); testpoints{xs(b)}(1,1); testpoints{xs(b)}(ys(b),2)];
               %two lines above replace this line: postracks{b}(:,end+1) = [i; testpoints{xs(b)}(1,1); testpoints{xs(b)}(ys(b),2)];
               
        testpoints{xs(b)}(ys(b),:) = []; % you linked a point, so it's no longer eligible
        points{max(2,i-xdist)-1+xs(b)}(ys(b),:) = [];
        if xs(b) == xdist+1 || xs(b) == i-1;
            unlinkedtracks{b} = [-2*xdist; -2*xdist; -2*xdist]; % if you just linked to the current frame, ensures that point won't be tested anymore
            xs(b) = nan;
            ys(b) = nan;
            distances(b) = nan;
        end
    end
    if mean(mean(horzcat(unlinkedtracks{:}),2)) == -2*xdist || isnan(a(1)) || alltoofar % if all tracks are linked or no points meet the linking criteria or none of the points link to the current frame or before
        Loc = find(cellfun(@(x) any(x(:)==-2*xdist),unlinkedtracks)==0); %unlinked (-2*xdist was my holder for the tracks that got linked)
        todel = [];
        for j = Loc 
            if unlinkedtracks{j}(1,end) < i - xdist % if there are unlinked tracks that stretch too far back, they're done
                todel(end+1) = j;
            end
            if length(postracks{j}(1,:))>=mintracklength % must have at least mintracklengthpoints to be counted
                activetracks{end+1} = postracks{j};
                todel(end+1) = j;
            end
        end
        Loc = find(cellfun(@(x) any(x(:)==-2*xdist),unlinkedtracks)==1); %linked
        for j = Loc
            if length(postracks{j}(1,:))>=mintracklength % must have at least mintracklengthpoints to be counted
                activetracks{end+1} = postracks{j};
                todel(end+1) = j;
            end
        end
        postracks(todel) = [];
        done = true;
    end
end
if ~isempty(points{i})
    for j = 1:length(points{i}(:,1))
        postracks{end+1} = [i; points{i}(j,:)'];
    end
end
end
tracks = [tracks activetracks];
n_tracks = length(tracks);

if graphtracks
%close all;
figure;
xvals = vertcat(pointscopy{:});
yvals = xvals(:,2);
xvals = xvals(:,1);
plot(xvals,yvals,'bo','markerfacecolor','b','markersize',4); hold on;
for i = 1:length(tracks)
    track = tracks{i};
    plot(track(2,:),track(3,:),'r-');
end
set(gca,'ydir','rev');
end
 %xlim([13000 15000]);


