function [x y mindist] = link (point, points,xdist,ydist)
% points is  a cell of j rows of x,y-values, but only the y-values
% will be used.
% point is am (x,y) pair you wish to find the closest points for, but the x
% is merely a placeholder (the frame number of the point - default would be 0).
% xdist is the number of frames to look ahead.  To look only one frame at a
% time, this value should be 0.

mindist = nan;
x = nan;
y = nan;

for i = max(point(1)+1,1):min(length(points),point(1)+xdist+1)
    if ~isempty(points{i})
        for j = 1:length(points{i}(:,1))
            dist = sqrt((i-1-point(1))^2/xdist^2+(points{i}(j,2)-point(2))^2/ydist^2); % -1 because the next frame is essentially a distance of 0 from the current frame
            if dist<min(sqrt(2),mindist) && abs(points{i}(j,2)-point(2))<=ydist % sqrt(3) is the maxdistance in this setup
                mindist = dist;
                x = i;
                y = j;
            end
        end
    end
end

