 function [newtracks n_t] = mergerltracks (tracks,rtracks,n_tracks,rn_tracks,minh,minv,numpingstoavg,strengths,rstrengths)

% tracks = TEMPtracks;
% rtracks = TEMPrtracks;
% n_tracks=length(tracks);
% TEMPtracks = tracks;
% TEMPrtracks = rtracks;
% n_tracks = length(TEMPtracks);
if nargin < 8
    bystrength = false;
    strengths = cell(size(tracks));
    for i = 1:length(tracks)
        strengths{i} = nan(size(tracks{i}(1,:)));
    end
    rstrengths = cell(size(rtracks));
    for i = 1:length(rtracks)
        rstrengths{i} = nan(size(rtracks{i}(1,:)));
    end
else
    bystrength = true;
end

if (~isempty(tracks) && size(tracks{1},1) == 3) || (~isempty(rtracks) && size(rtracks{1},1) == 3)% can input tracks with the index or not
    a = 2; b = 3;
else a = 1; b = 2;
end

rtracks = cellfun(@(x) fliplr(x(a:b,:)),rtracks,'uniformoutput',0);
rstrengths = cellfun(@(x) fliplr(x),rstrengths,'un',0);
tracks = cellfun(@(x) x(a:b,:),tracks,'uniformoutput',0);
n_tracks1 = n_tracks;
% tracks = TEMPtracks;
% rtracks = TEMPrtracks;

newtracks = cell(0);
n_t = 0;

i = 1; 


while ~isempty(tracks) && ~isempty(rtracks)
    goesinrtrack = false; %rtrack is a holder for tracks to still compare
    j = 1;
    
    while ~isempty(tracks) && j<=length(tracks{i})

        for iii = 1:length(tracks)
            if length(tracks{iii}(1,:))~=length(strengths{iii})
                disp('oi t');
            end
        end
        for iii = 1:length(rtracks)
            if length(rtracks{iii}(1,:))~=length(rstrengths{iii})
                disp('oi r');
            end
        end
        
        
        % for j = 1
        [intrack loc]= cellfun(@(x) ismember(tracks{i}(:,j)',x','rows'),rtracks);
        if sum(intrack) == 0
            j = j+1;
            continue;
        end
        tracknum = find(intrack == 1,1); %there should only be one, but just in case, only find the first one
        % if there is some overlap with a track, find the last value of overlap
        
        applyToGivenRow = @(func, matrix) @(row) func(matrix(row, :));
        applyToRows = @(func, matrix) arrayfun(applyToGivenRow(func, matrix), 1:size(matrix,1),'uniformoutput',0)';
        myfunc = @(x) ismember(x,rtracks{tracknum}','rows');
        whichpoints = applyToRows(myfunc, tracks{i}');
        whichpoints = vertcat(whichpoints{:})';
        
        range = [j find(whichpoints==1,1,'last')];
        rrange = [loc(tracknum) find(rtracks{tracknum}(1,:) == tracks{i}(1,range(2)))];
        % keep the track that has the deepest overall points (1 = reg direction)
        temptracks = {tracks{i} rtracks{tracknum}};
        tempstrengths = {strengths{i} rstrengths{tracknum}};
        
        if ~bystrength     
        [~, truetrack] = max([mean(tracks{i}(2,range(1):range(2))) mean(rtracks{tracknum}(2,rrange(1):rrange(2)))]);
        else
            [~, truetrack] = min([mean(strengths{i}(range(1):range(2))) mean(rstrengths{tracknum}(rrange(1):rrange(2)))]);
        end
        
        is1longb4 = range(1) > 1 && tracks{i}(1,range(1)-1) - tracks{i}(1,1) >= minh;
        is2longb4 = rrange(1) > 1 && rtracks{tracknum}(1,rrange(1)-1) - rtracks{tracknum}(1,1)>=minh;
        is1longafter = range(2)<length(tracks{i}) && tracks{i}(1,end) - tracks{i}(1,range(2)+1) >= minh;
        is2longafter = rrange(2)<length(rtracks{tracknum}) && rtracks{tracknum}(1,end)- rtracks{tracknum}(1,rrange(2)+1) >=minh;
        
        noearlytrack = false;
        nolatetrack = false;
        if is1longb4+is2longb4 <= 1
            [~, earlytrack] = min([tracks{i}(1,1) rtracks{tracknum}(1,1)]);
            if min([tracks{i}(1,1) rtracks{tracknum}(1,1)]) == tracks{i}(1,range(1))
                noearlytrack = true;
            end
            %newearlytrack = 0;
        else
            [~, earlytrack] = max([mean(tracks{i}(2,1:range(1))) mean(rtracks{tracknum}(2,1:rrange(1)))]);
            %newearlytrack = mod(earlytrack,2)+1; % the other one
        end

        if is1longafter+is2longafter <= 1
            [~, latetrack] = max([tracks{i}(1,end) rtracks{tracknum}(1,end)]);
            if max([tracks{i}(1,end) rtracks{tracknum}(1,end)]) == tracks{i}(1,range(2))
                nolatetrack = true;
            end
            %newlatetrack = 0;
        else
            [~, latetrack] = max([mean(tracks{i}(2,range(2):end)) mean(rtracks{tracknum}(2,rrange(2):end))]);
            %newlatetrack = mod(latetrack,2)+1; % the other one
        end
        ranges = {range rrange};
        Ttrack = [temptracks{earlytrack}(:,1:ranges{earlytrack}(1)-1) temptracks{truetrack}(:,ranges{truetrack}(1):ranges{truetrack}(2)) temptracks{latetrack}(:,ranges{latetrack}(2)+1:end)];
        Tstrengths = [tempstrengths{earlytrack}(1:ranges{earlytrack}(1)-1) tempstrengths{truetrack}(ranges{truetrack}(1):ranges{truetrack}(2)) tempstrengths{latetrack}(ranges{latetrack}(2)+1:end)];
        
        if latetrack == 2
            rtracks{end+1} = Ttrack;
            rstrengths{end+1} = Tstrengths;
            if is1longb4 && earlytrack == 2
                if ~goesinrtrack
                    n_t = n_t+1;
                    newtracks{n_t} = tracks{i}(:,1:range(1)-1);
                else
                    rtracks{end+1} = tracks{i}(:,1:range(1)-1);
                    rstrengths{end+1} = strengths{i}(1:range(1)-1);
                end
            end
            if is2longb4 && earlytrack == 1
                rtracks{tracknum} = rtracks{tracknum}(:,1:rrange(1)-1);
                rstrengths{tracknum} = rstrengths{tracknum}(1:rrange(1)-1);
            else
                rtracks(tracknum) = [];
                rstrengths(tracknum) = [];
            end
            if is1longafter
                tracks{i} = tracks{i}(:,range(2)+1:end);
                strengths{i} = strengths{i}(range(2)+1:end);
                j = 1;
                continue;
            else
                tracks(i) = [];
                strengths(i) = [];
                j = 1;
                n_tracks1 = length(tracks);
                goesinrtrack = false;
                continue;
            end
        end
        
        if nolatetrack
            if earlytrack == 2
                rtracks{tracknum} = Ttrack;
                rstrengths{tracknum} = Tstrengths;
                if is1longb4
                    if ~goesinrtrack
                        n_t = n_t+1;
                        newtracks{n_t} = tracks{i}(:,1:range(1)-1);
                    else
                        rtracks{end+1} = tracks{i}(:,1:range(1)-1);
                        rstrengths{end+1} = strengths{i}(1:range(1)-1);
                    end
                    tracks(i) = [];
                    strengths(i) = [];
                    n_tracks1 = n_tracks1-1;
                    goesinrtrack = false;
                    j = 1;
                    continue;
                end
            elseif earlytrack == 1 && ~noearlytrack
                if ~goesinrtrack
                    n_t = n_t+1;
                    newtracks{n_t} = Ttrack;
                else
                    rtracks{end+1} = Ttrack;
                    rstrengths{end+1} = Tstrengths;
                end
                if is2longb4
                    rtracks{tracknum} = rtracks{tracknum}(:,1:rrange(1)-1);
                    rstrengths{tracknum} = rstrengths{tracknum}(1:rrange(1)-1);
                else
                    rtracks(tracknum) = [];
                    rstrengths(tracknum) = [];
                end
                tracks(i) = [];
                strengths(i) = [];
                n_tracks1 = n_tracks1-1;
                goesinrtrack = false;
                j = 1;
                continue;
            elseif noearlytrack
                if ~goesinrtrack
                    n_t = n_t+1;
                    newtracks{n_t} = Ttrack;
                else
                    rtracks{end+1} = Ttrack;
                    rstrengths{end+1} = Tstrengths;
                end
                rtracks(tracknum) = [];
                rstrengths(tracknum) = [];
                tracks(i) = [];
                strengths(i) = [];
                n_tracks1 = n_tracks1-1;
                goesinrtrack = false;
                j = 1;
                continue;
            end
        end
        
        if latetrack == 1
            if is2longafter
                rtracks{end+1} = rtracks{tracknum}(:,rrange(2)+1:end);
                rstrengths{end+1} = rstrengths{tracknum}(rrange(2)+1:end);
            end
            if earlytrack == 2
                if is1longb4
                    if ~goesinrtrack
                        n_t = n_t+1;
                        newtracks{n_t} = tracks{i}(:,1:range(1)-1);
                    else
                        rtracks{end+1} = tracks{i}(:,1:range(1)-1);
                        rstrengths{end+1} = strengths{i}(1:range(1)-1);
                    end
                end
                goesinrtrack = true;
                rtracks(tracknum) = [];
                rstrengths(tracknum) = [];
            end
            if earlytrack == 1
                if is2longb4
                    rtracks{tracknum} = rtracks{tracknum}(:,1:rrange(1)-1);
                    rstrengths{tracknum} = rstrengths{tracknum}(1:rrange(1)-1);
                else
                    rtracks(tracknum) = [];
                    rstrengths(tracknum) = [];
                end
            end
            j = ranges{earlytrack}(1)+ranges{truetrack}(2) - ranges{truetrack}(1)+1;
            tracks{i} = Ttrack;
            strengths{i} = Tstrengths;
            continue
        end
        
    end
    if ~isempty(tracks) && ~goesinrtrack
        n_t = n_t+1;
        newtracks{n_t} = tracks{i};
        tracks(i) = [];
        strengths(i) = [];
    elseif ~isempty(tracks)
        rtracks{end+1} = tracks{i};
        rstrengths{end+1} = strengths{i};
        tracks(i) = [];
        strengths(i) = [];
        goesinrtrack = false;
    end
end

newtracks = [newtracks rtracks];
n_t = length(newtracks);

% now get rid of tracks that are too close together

[~, Index] = sort(cellfun('size', newtracks, 2), 'ascend');
newtracks = newtracks(Index);

remaind = max(cellfun(@(x) max(x(1,:)), newtracks))/numpingstoavg - floor(max(cellfun(@(x) max(x(1,:)), newtracks))/numpingstoavg);
stackedtracks = nan(n_t, ceil(max(cellfun(@(x) max(x(1,:)), newtracks))/numpingstoavg));
for i = 1:n_t
    stackedtracks(i,ceil(newtracks{i}(1,:)/numpingstoavg)) = newtracks{i}(2,:);
    %fill in gaps
    oi = find(~isnan(stackedtracks(i,:)));
    endpoints = [oi(1) oi(end)];
    for j = endpoints(1)+1:endpoints(2)-1
        if isnan(stackedtracks(i,j))
            stackedtracks(i,j) = round(nanmean([stackedtracks(i,j-1) stackedtracks(i,j+1)]));
        end
    end
end

keeptracks = ones(n_t,1);
for i = 1:n_t-1  %gets rid of the areas where tracks are too close by cycling through the shortest tracks
   
    tooclose = [];
    for j = i+1:n_t
        tooclose = [tooclose find(abs(stackedtracks(i,:)-stackedtracks(j,:))<=minv)];
    end
    % get rid of values that are by themselves or by twos.  Just one or two
    % points is okay in this set up
%     if i == 3
%         disp('oi');
%     end
    
    tooclose = tooclose(diff(tooclose) == 1);
    tooclose = tooclose(diff(tooclose) == 1);
    tooclose = union(union(tooclose,tooclose+1),tooclose+2);
    
    
    if length(tooclose)>2 %if there are more than 2 points in a row that are too close together
%         temptrack = newtracks{i};
        stackedtracks(i,tooclose) = nan;
        oi = find(~isnan(stackedtracks(i,:)));
             
        if isempty(oi) || oi(end)-oi(1) < minh/numpingstoavg
            keeptracks(i) = 0;
            continue;
        end
        endpoints = [oi(1) oi(end)];
        if any(tooclose> endpoints(2)) % use to be tooclose(1)>endpoints(2) some situations required this change.  
            newtracks{i} = newtracks{i}(:,newtracks{i}(1,:)<tooclose(1)*numpingstoavg);
            if length(newtracks{i}) < minh/numpingstoavg
                keeptracks(i) = 0;
            end
            continue;
        end
        if any(tooclose < endpoints(1)) % use to be tooclose(2)
           newtracks{i} = newtracks{i}(:,newtracks{i}(1,:)>tooclose(end)*numpingstoavg);
            if length(newtracks{i}) < minh/numpingstoavg
                keeptracks(i) = 0;
            end
            continue;
        end 
               
        
        newpoints = find(~isnan(stackedtracks(i,endpoints(1):endpoints(2))));
        gaps = diff(newpoints);
        sections = find(gaps>2);
%         if isempty(sections)
%             sectionlengths = length(
        sectionlengths = [sections(1) diff(sections) length(gaps)-sections(end)];
        trackworthy = (sectionlengths >= minh/numpingstoavg);
        if sum(trackworthy) ==0
            keeptracks(i) = 0;
        else
            temptracks = cell(length(sectionlengths),1);
            gaps = gaps(sections)-1;
            sectionlengths = [0 sectionlengths];
            gaps = [0 gaps];
            for j = 1:length(sectionlengths)-1
                temptracks{j} = nan(2,sectionlengths(j+1));
                temptracks{j}(1,:) = endpoints(1) + sum(sectionlengths(1:j)) + sum(gaps(1:j)):endpoints(1) + sum(sectionlengths(1:j)) + sum(gaps(1:j)) + sectionlengths(j+1)-1;
                temptracks{j}(2,:) = stackedtracks(i,temptracks{j}(1,:));
                temptracks{j}(1,:) = temptracks{j}(1,:)*numpingstoavg-numpingstoavg*(1-remaind);%(numpingstoavg-1);
            end
            temptracks(~trackworthy)= [];
            newtracks{i} = temptracks{1};
            for j = 2:length(temptracks);
                newtracks{end+1} = temptracks{j};
                keeptracks(end+1) = 1;
            end
        end
    end
end

newtracks = newtracks(~~keeptracks);
n_t = length(newtracks);

