function subs = sublayers(column, layers, minv, thresh, numpingstoavg)

global XI YI

if nargin>4
    column(isnan(column)) = 0;
    column = runmean(column,numpingstoavg);
%     column = medfilt2(column,[numpingstoavg 1]);
end

%%
% must be >thresh
% each peak must be wider than minv or be taller than 5*thresh & the middle
%  %% 3.17 10 * thresh was used in final analysis
% must be in the boundaries of the enveloping layer

subs = cell(1,length(layers(:,1)));
% subs1 = cell(1,length(layers(:,1)));
% subs2 = cell(1,length(layers(:,1)));
column(column<10^(thresh/10)) = 10^(thresh/10);

for i = 1:length(layers(:,1))
    testc = column(layers(i,1):layers(i,2));
    [peakLoc peakMag] = peakfinder(testc, 10*10^(thresh/10),2*10^(thresh/10));
    [~, b] = sort(peakMag,'descend');
    peakLoc = peakLoc(b);
    starts = nan(1,2*length(peakLoc));
    starts(1:2:end) = peakLoc;
    starts(2:2:end) = minv;
    err = 1000;
    numpeaks = 0;

    for j = 1:5 % 5 is arbitrary, but too many runs slow and seems not that likely
        if j<=length(peakLoc)
            [results, err2, residuals,~,xi,yi] =  peakfit(testc,0,0,j,1,1,1,starts(1:2*j),0,0,0);
        elseif isempty(peakLoc) && j == 1;
            [results, err2, residuals,~,xi,yi] =  peakfit(testc,0,0,j,1,1,1,[round(length(testc)/2) minv],0,0,0);
        else
            sts = nan(2*j,1);
            sts(1:2:length(starts)) = sort(starts(1:2:end));
            sts(2:2:end) = minv;
            for jj = 1:j-length(peakLoc)
               oi = [1; sort(peakLoc); length(testc)];
%                [maxgap b] = max(oi(2:end)-oi(1:end-1));
               sumr = nan(length(oi)-1,1);
               for ii = 1:length(oi)-1
                   oi2 = residuals(oi(ii):oi(ii+1),2);
                   sumr(ii) = sum(oi2(oi2>0));
               end
               [~, b] = max(sumr);
               [~, b2] = max(residuals(oi(b):oi(b+1)));
               sts(length(starts)+(jj-1)*2+1) = oi(b)+b2;
            end
            [results, err2, residuals,~,xi,yi] =  peakfit(testc,0,0,j,1,1,1,sts,0,0,0);
        end
        if min(results(:,3)) > 10^(thresh/10) && ~ismember(0,(2*results(:,4) > minv) + (results(:,3) > 5*10^(thresh/10))) && err2<err && min(results(:,2)) >= 1 && max(results(:,2))<length(testc)
            err = err2;
            numpeaks = j;
            heights = results(:,3);
            middles = results(:,2)+layers(i,1)-1;
            widths = results(:,4)/(2*sqrt(2*log(2)))*1.96; %the given widths are the FWHM.  This converts to 1.96sds
            XI = xi+layers(i,1)-1; YI = yi;
        end

    end

    
    
    
    subs{i} = nan(numpeaks,3);

    if err ~= 1000
        [heights b] = sort(heights,'descend');
        middles = middles(b);
        widths = widths(b);

        subs{i}(:,1) = round(middles-widths);
        subs{i}(subs{i}(:,1)<layers(i,1),1) = layers(i,1); % ensures that the sublayers don't extend beyond the main layer
        subs{i}(:,3) = round(middles+widths);
        subs{i}(subs{i}(:,3)>layers(i,2),3) = layers(i,2);
        subs{i}(:,2) = round(middles);

    end

    for j = 2:length(subs{i}(:,1))
        mergeT = find(subs{i}(j,1)<=subs{i}(1:j-1,3)+minv&subs{i}(j,1)>=subs{i}(1:j-1,1),1,'last');
        if ~isempty(mergeT)
            subs{i}(j,1) = subs{i}(mergeT,1);
        end
        mergeB = find(subs{i}(j,3)>=subs{i}(1:j-1,1)-minv&subs{i}(j,3)<=subs{i}(1:j-1,3),1,'last');
        if ~isempty(mergeB)
            subs{i}(j,3) = subs{i}(mergeB,3);
        end
    end
    
    % finds layers that are fairly identical (with borders that are < minv
    % apart) and makes them the same, keeping the avg value of the higher
    % peak
%     subs{i} = [layers(i,1) nan layers(i,2)]; % adds the overall layer for comparison
    bots = repmat(subs{i}(:,3)',numpeaks,1);
    difB = 0<=abs(bots-bots')&abs(bots-bots')<=minv;
    difB(1:numpeaks+1:end) = 0;
    topls = repmat(subs{i}(:,1)',numpeaks,1);
    difT = 0<=abs(topls - topls')&abs(topls - topls')<=minv;
    difT(1:numpeaks+1:end) = 0;
    [I J] = ind2sub(size(difB),find(triu(difB+difT) == 2));
    for ii = 1:length(I)
        if I(ii) == J(ii)
            continue;
        end        
        tokeep = min(I(ii),J(ii));
        subs{i}(tokeep,1) = min(subs{i}(I(ii),1),subs{i}(J(ii),1));
        subs{i}(tokeep,3) = max(subs{i}(I(ii),3),subs{i}(J(ii),3));
        todel = max(I(ii),J(ii));
        subs{i}(todel,:) = nan;
        I(I==todel) = tokeep;
        J(J==todel) = tokeep;
    end
    subs{i}(isnan(subs{i}(:,2)),:) = [];
       
end

