function [TRACKS TRACKSuna t cax h2] = tracklayers(transducer,ctdrgb,numpingstoavg,name,distances,TlayersT,TlayersB,GlayersT,GlayersM,GlayersB,xdist,ydist,minh,minv,initialfig,plotmeans,graphtracks,ys)

% davetracker method (start with middle)
% graphtracks = false;
% xdist = 12; %x max linking distance (skip gaps) (in samples,not pings)
% ydist = 50; %ymax linking distance
% minh = 24; % horizontal min length of layer (in samples)
% minv = 10; %vertical minimum separation between layers
% initialfig = 108;
% plotmeans = true; %running mean or original values

tic;
% TRACKS = cell(length(transducer),1);
lays = cell(1,5);
h2=figure(initialfig); clf;
% set(h2, 'WindowStyle', 'docked');
image(ctdrgb,'ydata', ys,'xdata',[1 size(transducer,1)],'alphadata',.3);
xlim([1 size(transducer,1)]); hold on;
lays{1} = TlayersT;
lays{2} = TlayersB;
lays{3} = GlayersM;

oi = vertcat(GlayersT{:}); plot(oi(:,1),oi(:,2),'bx','markersize',3); hold on;
oi = vertcat(GlayersM{:}); plot(oi(:,1),oi(:,2),'ks','markersize',1.5);
oi = vertcat(GlayersB{:}); plot(oi(:,1),oi(:,2),'go','markersize',3);
%         
for j = 1:3
    testlay = lays{j};
    if sum(cellfun(@(x) ~isempty(x),testlay)) ~= 0
        [tracks n_tracks] = davestracker(testlay,xdist,ydist,minh,minv,graphtracks);
        [rtracks rn_tracks] = davestracker(fliplr(testlay),xdist,ydist,minh,minv,false);
        strengths = addstrengths(tracks,testlay);
        rstrengths = addstrengths(rtracks,testlay);
        [tracks n_tracks] = mergerltracks(tracks,rtracks,n_tracks,rn_tracks,minh*numpingstoavg,minv,numpingstoavg,strengths,rstrengths);
    else
        n_tracks = 0;
        tracks = cell(0);
    end
    
    TRACKS = cell([n_tracks 1]);
    figure(initialfig);
    if j == 3
        TOPtrack = cell(n_tracks,1);
        BOTtrack = cell(n_tracks,1);
        trackst = cell(1,n_tracks);
        tracksb = cell(1,n_tracks);
    end
    for i_track = 1 : n_tracks
        track = tracks{i_track};
        TRACKS{i_track} = round([track(1,:)' track(2,:)']);
        if j == 1; if ~plotmeans; plot(TRACKS{i_track}(:,1), TRACKS{i_track}(:,2), 'r','linewidth',3); else
                plot(TRACKS{i_track}(:,1), runmean(TRACKS{i_track}(:,2),3), 'r','linewidth',3); end; end
        if j == 2; if ~plotmeans; plot(TRACKS{i_track}(:,1), TRACKS{i_track}(:,2), 'g','linewidth',3); else
                plot(TRACKS{i_track}(:,1), runmean(TRACKS{i_track}(:,2),3), 'g','linewidth',3); end; end
        if j == 3
            if ~plotmeans; plot(TRACKS{i_track}(:,1), TRACKS{i_track}(:,2), 'k','linewidth',1.5); else
                plot(TRACKS{i_track}(:,1), runmean(TRACKS{i_track}(:,2),3), 'k','linewidth',1.5); end
            TOPtrack{i_track}=cell(1,length(TRACKS{i_track}));
            BOTtrack{i_track}=cell(1,length(TRACKS{i_track}));
            oi = vertcat(GlayersM{:});
            oi3 = GlayersM;
            emptyrows = all(cellfun(@isempty,oi3),1);
            oi3(emptyrows) = mat2cell(rand(sum(emptyrows),2),ones(1,sum(emptyrows)),2);
            oi3 = vertcat(oi3{:});
            for jj = 1:length(TRACKS{i_track})
                colnum = find(oi3([diff(oi3(:,1))~=0; true],1)==TRACKS{i_track}(jj,1));
                rownum = find(oi(oi(:,1)==TRACKS{i_track}(jj,1),2)==TRACKS{i_track}(jj,2));
                if isempty(colnum) || isempty(rownum); continue; end
                TOPtrack{i_track}{jj} = GlayersT{colnum}(rownum,:);
                BOTtrack{i_track}{jj} = GlayersB{colnum}(rownum,:);
            end
            if sum(cellfun(@isempty, TOPtrack{i_track})) == length(TOPtrack{i_track})
                trackst{i_track} = cell(1,0);
            else
                [tracksTemp n_tracks] = davestracker(TOPtrack{i_track}, xdist,ydist,minh,minv,0);
                [rtracks rn_tracks] = davestracker(fliplr(TOPtrack{i_track}),xdist,ydist,minh,minv,false);
                trackst{i_track} = mergerltracks(tracksTemp,rtracks,n_tracks,rn_tracks,minh*numpingstoavg,minv,numpingstoavg);
            end
            if sum(cellfun(@isempty, BOTtrack{i_track})) == length(BOTtrack{i_track})
                tracksb{i_track} = cell(1,0);
            else
                [tracksTemp n_tracks] = davestracker(BOTtrack{i_track}, xdist,ydist,minh,minv,0);
                [rtracks rn_tracks] = davestracker(fliplr(BOTtrack{i_track}),xdist,ydist,minh,minv,false);
                tracksb{i_track} = mergerltracks(tracksTemp,rtracks,n_tracks,rn_tracks,minh*numpingstoavg,minv,numpingstoavg);
            end
        end
    end
    if j == 1; tracksthT = cellfun(@(x) x',TRACKS,'un',0); end
    if j == 2; tracksthB = cellfun(@(x) x',TRACKS,'un',0); end
end

if ~isempty(trackst)
    trackst = horzcat(trackst{:})';
    rtrackst = cellfun(@(x) fliplr(x),trackst,'un',0);
    [trackst n_tracks] = mergerltracks(trackst,rtrackst,length(trackst),length(trackst),minh*numpingstoavg,minv,numpingstoavg);
    for ii = 1:n_tracks
        if ~plotmeans; plot(trackst{ii}(1,:),trackst{ii}(2,:),'color',[178 34 34]/255,'linewidth',2); else
            plot(trackst{ii}(1,:),runmean(trackst{ii}(2,:),3),'color',[178 34 34]/255,'linewidth',2); end
    end
end
if ~isempty(tracksb)
    tracksb = horzcat(tracksb{:})';
    rtracksb = cellfun(@(x) fliplr(x),tracksb,'un',0);
    [tracksb bn_tracks] = mergerltracks(tracksb,rtracksb,length(tracksb),length(tracksb),minh*numpingstoavg,minv,numpingstoavg);
    for ii = 1:bn_tracks
        if ~plotmeans; plot(tracksb{ii}(1,:),tracksb{ii}(2,:),'color',[34 139 34]/255,'linewidth',2); else
            plot(tracksb{ii}(1,:),runmean(tracksb{ii}(2,:),3),'color',[34 139 34]/255,'linewidth',2); end
    end
end
% layernum = 1;
% sectionlength = size(transducer,1);
TRACKS = cell(5,1);
TRACKS{1} = tracksthT;
TRACKS{2} = tracksthB;
TRACKS{3} = trackst;
TRACKS{4} = tracks;
TRACKS{5} = tracksb;
TRACKSuna=TRACKS;
% if plotmeans
    for ii = 1:5
        for jj = 1:length(TRACKS{ii})
            TRACKS{ii}{jj}(2,:)= runmean(TRACKS{ii}{jj}(2,:),3);
        end
    end
% end
title(name); ylim([0 600]);



keep = false; % if you want to keep the current specified distances

cax = gca; %usually gca or a specific axis

set(cax,'xtickmode','auto','xticklabelmode','auto');
% set(cax,'xlim',[350 8200])
% set(cax,'xlim',[800 2400])

oi = get(cax,'xtick');
xs = get(cax,'xlim');
% set(gca,'xticklabel',round(10*distances(oi))/10);

if keep; dist = newdist; else dist = distances; end
gooddist = round(dist(oi(2))-dist(oi(1)));
if gooddist<=1; gooddist = round(10*(dist(oi(2))-dist(oi(1))))/10; end
if gooddist<=.1; gooddist = round(100*(dist(oi(2))-dist(oi(1))))/100; end
b = nan(1,floor((dist(xs(2))-dist(xs(1)))/gooddist));
for i = 1:length(b)
    [~, b(i)] = min(abs(dist(xs(1):xs(2))-dist(xs(1))-gooddist*i));
end
b= b+xs(1);
b(diff(b)==0) = b(diff(b)==0)-1;
b(diff(b)==0) = b(diff(b)==0)-1;
set(cax,'xtick',b);
if ~keep; beg = gooddist; else beg = round(dist(b(1))); end
% set(cax,'xticklabel',beg:gooddist:beg+gooddist*(length(b)-1));
% 
% if ~keep
%     newdist = distances-(distances(b(1))-gooddist);
% end
% 
% %% comment out line before and run with this to get ping # also (stopped
% %% working because of an issue with the units)
xtl = cell(1,length(b));
for i = 1:length(b)
    xtl{i} = {num2str(gooddist+(i-1)*gooddist); num2str(b(i))};
end
h = my_xticklabels(cax,b,xtl);
% xlabel('Distance in km, ping #');
ylabel('Depth (m)');
t = toc ;