function [threshLAY type2LAY type3LAY middles] = ziplayersp(transducer, thresh, topsT, bottomsT, tops, middles, bottoms, numpingstoavg, minh,minv)
% zip together layer files

% topsT = TRACKS{1}{1};
% bottomsT = TRACKS{1}{2};
% tops = TRACKS{1}{3};
% bottoms = TRACKS{1}{5};
% middles = TRACKS{1}{4};
% numpingstoavg = 7;

tracks = {topsT bottomsT tops middles bottoms};
firstping = nan;
lastping = nan;

for i = 1:5
    firstpings = cellfun(@(x) min(x(1,:)), tracks{i}); firstping = int32(min([firstping min(firstpings)]));
    lastpings = cellfun(@(x) max(x(1,:)), tracks{i}); lastping = int32(max([lastping max(lastpings)]));
    [~, b] = sort(lastpings-firstpings,'descend');
    tracks{i} = tracks{i}(b);
    %inpaint values so that no pings are skipped
    for j = 1:length(tracks{i})
        difpings = diff(tracks{i}{j}(1,:));
        tracks{i}{j}(:,difpings==0) = []; difpings(difpings==0) = []; % from a problem where a track started with the same ping twice.
        fixpings = find(round(difpings)~=numpingstoavg)+1;
        if isempty(fixpings); tracks{i}{j} = int32(tracks{i}{j}); continue; end  %was empty inSEns 104
        pinggaps = difpings(fixpings-1)/numpingstoavg-1;
        newtrack = nan(2,sum(pinggaps));
        newtrack(1,cumsum(pinggaps)) = tracks{i}{j}(1,fixpings)-numpingstoavg;
        gaps = find(isnan(newtrack(1,:)) == 1);
        depthgaps = (tracks{i}{j}(2,fixpings)-tracks{i}{j}(2,fixpings-1))./(pinggaps+1);
        newtrack(2,cumsum(pinggaps)) = tracks{i}{j}(2,fixpings)-depthgaps;
        for ii = length(gaps):-1:1
            newtrack(1,gaps(ii)) = newtrack(1,gaps(ii)+1)-numpingstoavg;
            oi = newtrack(1,gaps(ii))-tracks{i}{j}(1,fixpings);
            oi(oi>0) = nan;
            [~, b] = max(oi);
            newtrack(2,gaps(ii)) = newtrack(2,gaps(ii)+1)-depthgaps(b);
        end
        [newtrack1 I] = sort([tracks{i}{j}(1,:) newtrack(1,:)]);
        newtrack2 = [tracks{i}{j}(2,:) newtrack(2,:)];
        newtrack2 = newtrack2(I);
        tracks{i}{j} = int32([newtrack1; round(newtrack2)]);
    end
end

[tracks{1} tracks{2}] = cutoffcrossings(tracks{1}, tracks{2}, numpingstoavg, minh, 'thresh',minv);



%larger threshold layer
threshLAY= -ones(601,(lastping-firstping+numpingstoavg)/numpingstoavg);
threshLAY(1,:) = firstping:numpingstoavg:lastping;
depths = 1:600;
empties = ~~cellfun(@isempty,tracks);
if empties(1) || empties(2); type2LAY = threshLAY; type3LAY = threshLAY; middles = []; return; end

for i = 1:size(threshLAY,2)
    ping = threshLAY(1,i);
    layersT = cell2mat(cellfun(@(x) int32(x(2,x(1,:) == ping)),tracks{1},'un',0)')';
    layersT = [ones(size(layersT,1),1) layersT];
    layersB = cell2mat(cellfun(@(x) int32(x(2,x(1,:) == ping)),tracks{2},'un',0)')';
    layersB = [2*ones(size(layersB,1),1) layersB];
    [~, I] = sort([layersT(:,2); layersB(:,2)]);
    layers = [layersT; layersB];
    layers = layers(I,:);
    M = zeros(size(depths));
    checkdepth1 = false;
    if ~isempty(layers) && layers(1,2) == 1; layers(1,2) =2; checkdepth1 = true; end % ensures there is a 0 in the first depth bin adds in later if necesary
    for j = 1:length(layers(:,1))
        if layers(j,1) == 1 %layertype is top
            if j~=length(layers(:,1)); M(depths>=layers(j,2)) = true; end %ensures there's a bottom below the top
            % if the layer above is still 1s and it's below the thresh
            if M(layers(j,2)-1) && nanmean(nanmean(10.^(transducer(ping:ping+numpingstoavg-1,layers(j-1,2):layers(j,2))./10),2))<10^(thresh/10)
                M(find(~M(1:layers(j,2)-1),1,'last'):layers(j,2)-1) = false;
            end
        else %layertype = 2 (bottom)
            M(depths>layers(j,2)) = false;
            %but if this is the second bottom in a row and the intervening
            % samples meet the thresh criteria, keep them as true
            if j>1 && layers(j-1,1) == 2 && nanmean(nanmean(10.^(transducer(ping:ping+numpingstoavg-1,layers(j-1,2):layers(j,2))./10),2))>10^(thresh/10)
                M(depths<layers(j,2)&depths>layers(j-1,2)) = true;
            end
        end
    end
    if checkdepth1 && M(2); M(1) = true; end
    %     threshLAY(2:length(depths(~~M))+1,i) = depths(~~M);
    threshLAY(depths(~~M)+1,i) = depths(~~M);
end

type2LAY= -ones(601,(lastping-firstping+numpingstoavg)/numpingstoavg);
type2LAY(1,:) = firstping:numpingstoavg:lastping;
depths = 1:600;

[tracks{3} tracks{5}] = cutoffcrossings(tracks{3}, tracks{5}, numpingstoavg, minh);
if empties(3) || empties(5); type3LAY = type2LAY; middles = []; return; end

for i = 1:size(type2LAY,2)
    ping = type2LAY(1,i);
    layersT = cell2mat(cellfun(@(x) int32(x(2,x(1,:) == ping)),tracks{3},'un',0))';
    layersT = [ones(size(layersT,1),1) layersT];
    layersB = cell2mat(cellfun(@(x) int32(x(2,x(1,:) == ping)),tracks{5},'un',0))';
    layersB = [2*ones(size(layersB,1),1) layersB];
    [~, I] = sort([layersT(:,2); layersB(:,2)]);
    layers = [layersT; layersB];
    layers = layers(I,:);
    M = zeros(size(depths));
    checkdepth1 = false;
     
    if ~isempty(layers) && layers(1,2) == 1; layers(1,2) =2; checkdepth1 = true; end % ensures there is a 0 in the first depth bin adds in later if necesary
    for j = 1:length(layers(:,1))
        if layers(j,1) == 1 %layertype is top
            if ismember(2,layers(j:end,1)); M(depths>=layers(j,2)) = true; end %ensures there's a bottom below the top
            if M(layers(j,2)-1)
                M(find(~M(1:layers(j,2)-1),1,'last'):layers(j,2)-1) = false;
            end
        else %layertype = 2 (bottom)
            M(depths>layers(j,2)) = false;
        end
    end
    if checkdepth1 && M(2); M(1) = true; end
    threshdepths = depths.*ismember(depths,threshLAY(2:end,threshLAY(1,:) == ping));
    threshdepths(threshdepths==0) = -1; %limits the type 2 layers to being within the threshold layers
    %     type2LAY(2:length(depths(~~M))+1,i) = threshdepths(~~M);
    type2LAY(depths(~~M)+1,i) = threshdepths(~~M);
end

% type 3
withmiddles = false; % if true ensures that you only have a type 3 layer if there is a middle

type3LAY= -ones(601,(lastping-firstping+numpingstoavg)/numpingstoavg);
type3LAY(1,:) = firstping:numpingstoavg:lastping;
depths = 1:600;

if withmiddles
    for i = 1:size(type3LAY,2)
        ping = type3LAY(1,i);
        layersT = cell2mat(cellfun(@(x) x(2,x(1,:) == ping),tracks{3},'un',0))';
        layersT = [ones(size(layersT,1),1) layersT];
        layersB = cell2mat(cellfun(@(x) x(2,x(1,:) == ping),tracks{5},'un',0))';
        layersB = [2*ones(size(layersB,1),1) layersB];
        layersM = cell2mat(cellfun(@(x) x(2,x(1,:) == ping),tracks{4},'un',0))';
        layersM = [3*ones(size(layersM,1),1) layersM];
        layers2 = type2LAY(2:end,type2LAY(1,:)==ping);
        [a I] = sort([layersT(:,2); layersB(:,2); layersM(:,2)]);
        layers = [layersT; layersB; layersM];
        layers = layers(I,:);
        layers(layers(1:end-1,1)==3 & diff(layers(:,1)) == 0,:)=[]; % gets rid of double middles for purposes of finding type 3
        M = zeros(size(depths));
        checkdepth1 = false;
        if ~isempty(layers) && layers(1,2) == 1; layers(1,2) =2; checkdepth1 = true; end % ensures there is a 0 in the first depth bin adds in later if necesary
        for j = 3:length(layers(:,1))-2
            if layers(j,1) == 1 && layers(j-2,1) == 1 && layers(j-1,1) == 3 && ismember(layers(j,2),layers2) % && (layers(j+1,1) == 2 || (layers(j+1,1) == 3 && layers(j+2,1)==2))
                M(depths>=layers(j-2,2)&depths<=layers(j,2)) = true;
            elseif layers(j,1) == 2 && layers(j+2,1) ==2 && layers(j+1,1) == 3 && ismember(layers(j,2),layers2)
                M(depths<=layers(j+2,2)&depths>=layers(j,2)) = true;
            end
        end
        if checkdepth1 && M(2); M(1) = true; end
        threshdepths = depths.*ismember(depths,threshLAY(2:end,threshLAY(1,:) == ping));
        threshdepths(threshdepths==0) = -1; %limits the type 2 layers to being within the threshold layers
        layers2(layers2==-1) = [];
        M(layers2) = true;
        type3LAY(depths(~~M)+1,i) = threshdepths(~~M);
    end
else
    for i = 1:size(type3LAY,2)
        ping = type3LAY(1,i);
        layersT = cell2mat(cellfun(@(x) int32(x(2,x(1,:) == ping)),tracks{3},'un',0))';
        layersT = [ones(size(layersT,1),1) layersT];
        layersB = cell2mat(cellfun(@(x) int32(x(2,x(1,:) == ping)),tracks{5},'un',0))';
        layersB = [2*ones(size(layersB,1),1) layersB];
        layers2 = type2LAY(2:end,type2LAY(1,:)==ping);
        [~, I] = sort([layersT(:,2); layersB(:,2)]);
        layers = [layersT; layersB];
        layers = layers(I,:);
        M = zeros(size(depths));
        checkdepth1 = false;
        if ~isempty(layers) && layers(1,2) == 1; layers(1,2) =2; checkdepth1 = true; end % ensures there is a 0 in the first depth bin adds in later if necesary
        for j = 2:length(layers(:,1))-1
            if layers(j,1) == 1 && layers(j-1,1) == 1 && ismember(layers(j,2),layers2) % && (layers(j+1,1) == 2 || (layers(j+1,1) == 3 && layers(j+2,1)==2))
                M(depths>=layers(j-1,2)&depths<=layers(j,2)) = true;
            elseif layers(j,1) == 2 && layers(j+1,1) ==2 && ismember(layers(j,2),layers2)
                M(depths<=layers(j+1,2)&depths>=layers(j,2)) = true;
            end
        end
        if checkdepth1 && M(2); M(1) = true; end
        threshdepths = depths.*ismember(depths,threshLAY(2:end,threshLAY(1,:) == ping));
        threshdepths(threshdepths==0) = -1; %limits the type 2 layers to being within the threshold layers
        layers2(layers2==-1) = [];
        M(layers2) = true;
        type3LAY(depths(~~M)+1,i) = threshdepths(~~M);
    end
end
  
% check for skinny sections that are not within a type2
testLAY = type3LAY(2:end,:);
testLAY(testLAY>0) =1;
testLAY(testLAY==-1) = 0;
testLAY = [type3LAY(1,:); testLAY];
for k = [1 2 3 5] % add borders for all but middles
    for i = 1:length(tracks{k})
        % fill in vertical gaps so that all boundaries are taken care of
        row = tracks{k}{i}(2,:);
        gaps = find(abs(diff(row))>1);
        newrows = int32([]);
        for j = 1:length(gaps)
            direc = sign(row(gaps(j)+1)-row(gaps(j))); % determines if the line is going up or down
            oi = int32(row(gaps(j))+direc:direc:row(gaps(j)+1)-direc);
            newrow = int32(tracks{k}{i}(1,gaps(j)))*int32(ones(2,length(oi)));
            newrow(2,:) = oi;
            newrows = [newrows newrow];
        end
        newrows = int32([newrows tracks{k}{i}]);
        cols = int32(arrayfun(@(x) find(round(testLAY(1,:))==x),round(newrows(1,:))));
        I = sub2ind(size(type3LAY),newrows(2,:)+1,cols);
        testLAY(I) = Inf;
    end
end

for i = 2:size(testLAY,1)
    row = find(testLAY(i,:)~=0);
    if isempty(row); continue; end
    ends = [row(diff(row)>2) row(end)]; %ends of contiguous sections (counts a gap of one as contiguous, since it's likely just an error)
    begs = [row(1) row(find(diff(row)>2)+1)];
    for j = 1:length(ends)
        testLAY(i,begs(j):ends(j)) = sum(testLAY(i,begs(j):ends(j)));
    end
end

testLAY(1,:) = true;
testLAY(2:end,:) = (testLAY(2:end,:)>=minh);
testLAY(2:end,:) = (testLAY(2:end,:)+type2LAY(2:end,:)>=0)>0;
type3LAY = type3LAY.*testLAY;

% get rid of small patches that aren't at least minh long at their widest
LAYs = {threshLAY type2LAY type3LAY};

for k = 1:3
    testLAY = LAYs{k}(2:end,:);
    testLAY(testLAY<1) = 0;
    testLAY(testLAY>1) = 1;
    testLAY(:,end+1:end+2) = 0;
    testLAY(:,2:end) = testLAY(:,1:end-1);
    testLAY(:,1) = 0;
    
    [~, h] = contourf(testLAY,1);
    patches = get(h,'children');
    [Is Js] = ind2sub(size(testLAY),1:size(testLAY,1)*size(testLAY,2));
    
    for i = 1:length(patches)-1
        x = get(patches(i),'xdata');
        y = get(patches(i),'ydata');
        if max(x)-min(x)<minh
            in = reshape(inpolygon(Js,Is,x,y),size(testLAY));
            testLAY(in) = 0;
        end
    end
    delete(h); testLAY = testLAY(:,2:end-1);
    LAYs{k}(2:end,:) = LAYs{k}(2:end,:).*testLAY;
end
[threshLAY type2LAY type3LAY] = LAYs{:};
      
   


% now adjust middle lines
%first get rid of any middle parts that are not within a type3LAY
middles = tracks{4};
todel = [];
for i = 1:length(tracks{4})
    cols = arrayfun(@(x) find(round(type3LAY(1,:))==x),round(tracks{4}{i}(1,:)));
%     cols = horzcat(cols{:});
    oi = nan(1,length(cols));
    for j = 1:length(tracks{4}{i})
        oi(j) = ismember(tracks{4}{i}(2,j),type3LAY(2:end,cols(j)));
    end
    middles{i}(2,:) = middles{i}(2,:).*int32(oi);
    sections = find(middles{i}(2,:)~=0);
    if isempty(sections)
        todel = [todel i];
        continue
    end
    begs = sections([1 find(diff(sections)>2)+1]);
    ends = sections([find(diff(sections)>2) length(sections)]);
    for j = 1:length(begs)
        if j == 1
            middles{i} = tracks{4}{i}(:,begs(j):ends(j));
            if length(middles{i})<=2; todel = [todel i]; end % gets rid of essentially individual points that are within the region.  Seem unnecessary
        else
            middles{end+1} = tracks{4}{i}(:,begs(j):ends(j));
            if length(middles{end})<=2; todel = [todel length(middles)]; end
        end
    end
end
middles(todel) = [];
[~,I] = sort(cellfun(@length,middles),'descend');
middles = middles(I);


multmiddles = true; %allows for multiple middles within a type3

% now loop through the shortest sections, get rid of them if there is
% another middle
testLAY = type3LAY;
testLAY(2:end,:) = (type3LAY(2:end,:)>=1);
testLAY(1,:) = type3LAY(1,:); %if type2LAY and type3LAY aren't the same size, problems ensue, but they should be the same size
testLAY(2:end,:) = testLAY(2:end,:)+(type2LAY(2:end,:)>=1); %2s for type 2, 1s for type 3, top row is pings
todel = [];
for i = 1:length(middles)
    cols = arrayfun(@(x) find(testLAY(1,:)==x),round(middles{i}(1,:)));
    for j = 1:length(middles{i})
        if testLAY(middles{i}(2,j),cols(j)) >= 1
            if ~multmiddles || testLAY(middles{i}(2,j),cols(j)) > 1
                val = testLAY(middles{i}(2,j),cols(j));
                top = find(testLAY(2:middles{i}(2,j),cols(j))~=val,1,'last')+1;
                if all(testLAY(middles{i}(2,j):end,cols(j))==val) % an error when the potential middles extend all the way tot he bottom
                    bot = testLAY(end,cols(j))-1;
                else
                    bot = find(testLAY(middles{i}(2,j):end,cols(j))~=val,1,'first')+middles{i}(2,j)-2;
                end
                testLAY(top+1:bot+1,cols(j)) =0;
            else continue
            end
        else
            middles{i}(2,j) = 0;
        end
    end
    %now cut up middles again
    sections = find(middles{i}(2,:)~=0);
    if isempty(sections)
        todel = [todel i];
        continue
    end
    begs = sections([1 find(diff(sections)>1)+1]);
    ends = sections([find(diff(sections)>1) length(sections)]);
    for j = length(begs):-1:1
        if j == 1
            middles{i} = middles{i}(:,begs(j):ends(j));
            if length(middles{i})<=2; todel = [todel i]; end % gets rid of essentially individual points that are within the region.  May be unnecessary with above changes
        else
            middles{end+1} = middles{i}(:,begs(j):ends(j));
            if length(middles{end})<=2; todel = [todel length(middles)]; end
        end
    end
end
middles(todel) = [];
[~,I] = sort(cellfun(@length,middles),'descend');
middles = middles(I);

    



